#include <Arduino.h>
#include <PCA9685.h>


const uint8_t DEVICE_ADDRESS = 0x40;
const size_t OUTPUT_ENABLE_PIN = 2;

const size_t LOOP_DELAY = 100;
const uint16_t FREQUENCY_INCREMENT = 10;

uint16_t frequency_min;
uint16_t frequency_max;
uint16_t frequency;

PCA9685 pca9685;

void setup()
{
  pca9685.setWire(Wire);
  pca9685.addDevice(DEVICE_ADDRESS);
  pca9685.resetAllDevices();
  pca9685.setupOutputEnablePin(OUTPUT_ENABLE_PIN);
  pca9685.enableOutputs(OUTPUT_ENABLE_PIN);
  pca9685.setOneDeviceOutputsNotInverted(DEVICE_ADDRESS);

  uint16_t time_min = pca9685.getTimeMin();
  uint16_t time_max = pca9685.getTimeMax();
  pca9685.setAllDeviceChannelsOnAndOffTime(DEVICE_ADDRESS,time_min,time_max/4);

  frequency_min = pca9685.getFrequencyMin();
  frequency_max = pca9685.getFrequencyMax();

  frequency = frequency_min;
}

void loop()
{
  if (frequency > frequency_max)
  {
    frequency = frequency_min;
  }
  pca9685.setOneDeviceToFrequency(DEVICE_ADDRESS,frequency);
  frequency += FREQUENCY_INCREMENT;
  delay(LOOP_DELAY);
}
